## glib2.0 2.64.6

=== debian/changelog ===
glib2.0 (2.64.6-1~ubuntu20.04.9) focal-security; urgency=medium

  * SECURITY UPDATE: Integer Overflow
    - debian/patches/CVE-2025-4373-1.patch: carefully handle gssize
      in glib/gstring.c.
    - CVE-2025-4373

 -- Leonidas Da Silva Barbosa <leo.barbosa@canonical.com>  Mon, 12 May 2025 07:24:59 -0300

glib2.0 (2.64.6-1~ubuntu20.04.8) focal-security; urgency=medium

  * SECURITY UPDATE: Buffer overflow
    - debian/patches/CVE-2024-52533.patch: fix a single byte buffer
      overflow in connect messages in gio/gsocks4aproxy.c.
    - CVE-2024-52533

 -- Leonidas Da Silva Barbosa <leo.barbosa@canonical.com>  Wed, 13 Nov 2024 16:12:53 -0300

glib2.0 (2.64.6-1~ubuntu20.04.7) focal-security; urgency=medium

  [ Marco Trevisan (Treviño) ]
  * debian/patches: Backport patches to handle CVE-2024-34397

  [ Marc Deslauriers ]
  * debian/patches/CVE-2024-34397/gdbusconnection-regression.patch: fix
    ibus regression.

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Wed, 08 May 2024 13:30:11 -0400

glib2.0 (2.64.6-1~ubuntu20.04.6) focal-security; urgency=medium

  * SECURITY UPDATE: multiple GVariant security issues
    - debian/patches/gvariant-security-*.patch: backported upstream fixes
      for GVariant normalization issues.
    - CVE-2023-24593, CVE-2023-29499, CVE-2023-25180, CVE-2023-32611,
      CVE-2023-32636, CVE-2023-32643, CVE-2023-32665

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Thu, 08 Jun 2023 10:20:31 -0400

glib2.0 (2.64.6-1~ubuntu20.04.4) focal; urgency=medium

  * Initialise memory used for file builder buffers to zero, since memory
    artifacts found themseleves into gschema.compiled files, leading to glib
    being unable to parse the gschema.compiled files, causing gdm, gnome-shell
    and various gnome applications to fail to
    start. (LP: #1930359)
      - d/p/gvdb-builder-Initialise-some-memory-to-zero-in-the-bloom-.patch

 -- Matthew Ruffell <matthew.ruffell@canonical.com>  Mon, 12 Jul 2021 15:56:16 +0100

glib2.0 (2.64.6-1~ubuntu20.04.3) focal-security; urgency=medium

  * SECURITY UPDATE: incorrect g_file_replace() symlink handling
    - debian/patches/CVE-2021-28153-1.patch: fix a typo in a comment in
      gio/glocalfileoutputstream.c.
    - debian/patches/CVE-2021-28153-2.patch: stop using g_test_bug_base()
      in file tests in gio/tests/file.c.
    - debian/patches/CVE-2021-28153-3.patch: factor out a flag check in
      gio/glocalfileoutputstream.c.
    - debian/patches/CVE-2021-28153-4.patch: fix CREATE_REPLACE_DESTINATION
      with symlinks in gio/glocalfileoutputstream.c, gio/tests/file.c.
    - debian/patches/CVE-2021-28153-5.patch: add a missing O_CLOEXEC flag
      to replace() in gio/glocalfileoutputstream.c.
    - CVE-2021-28153

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Fri, 12 Mar 2021 11:38:38 -0500

glib2.0 (2.64.6-1~ubuntu20.04.2) focal-security; urgency=medium

  * SECURITY UPDATE: g_byte_array_new_take length truncation
    - debian/patches/CVE-2021-2721x/CVE-2021-27218.patch: do not accept too
      large byte arrays in glib/garray.c, glib/gbytes.c,
      glib/tests/bytes.c.
    - CVE-2021-27218
  * SECURITY UPDATE: integer overflow in g_bytes_new
    - debian/patches/CVE-2021-2721x/CVE-2021-27219*.patch: add internal
      g_memdup2() function and use it instead of g_memdup() in a bunch of
      places.
    - CVE-2021-27219

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Tue, 02 Mar 2021 12:28:09 -0500

glib2.0 (2.64.6-1~ubuntu20.04.1) focal; urgency=medium

  [ Iain Lane ]
  * New upstream release (LP: #1907433), fixing bugs:
    - Ensure g_subprocess_communicate_async() never blocks
    - Fix large writes in gfileutils
    - Fix splice behavior on cancellation
    - gdatetime: Avoid integer overflow creating dates too far in the past
    - gdesktopappinfo: Fix unnecessarily copied and leaked URI list
    - gthreadedresolver: faulty logic in parse_res_txt
    - gtk3/glib crash on gimp
    - gvariant: Ensure GVS.depth is initialised
    - trash portal: Handle portal failures
  * gbp.conf: Set upstream branch to upstream/2.64.x
  * Drop patches applied upstream:
    - glib-compile-resources-Fix-exporting-on-Visual-Studio.patch
    - gdesktopappinfo-Fix-unnecessarily-copied-and-leaked-URI-l.patch
  * Revert changes from Debian which we don't need in this SRU:
    + Revert "d/tests/build: Don't exercise static linking for GIO"
    + control{,.in}: Re-lower libmount BD version.
      The problems that prompted this to be raised happened post-focal.

 -- Iain Lane <iain.lane@canonical.com>  Wed, 09 Dec 2020 11:23:14 +0000

glib2.0 (2.64.4-1) unstable; urgency=medium

  * Team upload
  * New upstream release
    - Improve async-signal-safety
  * d/tests/build: Don't exercise static linking for GIO.
    libmount will no longer support being linked statically from 2.35.2-8
    onwards. For now I'm continuing to test that the other libraries can
    still be statically linked, but please consider them to be "at risk".
    (Closes: #963933)
  * Re-enable libmount support.
    libmount no longer depends on libcryptsetup, avoiding the various
    crashes that we are working around. Future versions will dlopen it
    on-demand, which should also avoid those crashes. Bump the
    build-dependency to a suitable version.
  * d/p/tests-Use-g_assert_-in-cancellable-test-rather-than-g_ass.patch,
    d/p/gcancellable-Fix-minor-race-between-GCancellable-and-GCan.patch:
    Split combined d/p/git_gsource_segfault.patch into its two component
    upstream commits, and add metadata
  * d/p/glib-compile-resources-Fix-exporting-on-Visual-Studio.patch,
    d/p/gdesktopappinfo-Fix-unnecessarily-copied-and-leaked-URI-l.patch:
    Add post-release bugfixes from upstream

 -- Simon McVittie <smcv@debian.org>  Tue, 07 Jul 2020 13:33:01 +0100

glib2.0 (2.64.3-2) unstable; urgency=medium

  * Team upload
  * Temporarily disable libmount support.
    Recent Debian revisions of libmount pull in libcryptsetup as a


=== debian/control ===
# This file is autogenerated. DO NOT EDIT!
#
# Modifications should be made to debian/control.in instead.
# This file is regenerated automatically in the clean target.
Source: glib2.0
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian GNOME Maintainers <pkg-gnome-maintainers@lists.alioth.debian.org>
Uploaders: Iain Lane <laney@debian.org>
Build-Depends: dbus <!nocheck>,
               debhelper-compat (= 12),
               desktop-file-utils <!nocheck>,
               dh-exec,
               dh-python,
               docbook-xml,
               docbook-xsl,
               dpkg-dev (>= 1.17.14),
               gettext,
               gnome-pkg-tools (>= 0.11),
               gtk-doc-tools (>= 1.32-4~),
               libdbus-1-dev (>= 1.2.14) <!nocheck> <!noinsttest>,
               libelf-dev (>= 0.142),
               libffi-dev (>= 3.3),
               libgamin-dev [hurd-any] | libfam-dev [hurd-any],
               libmount-dev (>= 2.28) [linux-any],
               libpcre3-dev (>= 1:8.35),
               libselinux1-dev [linux-any],
               libxml2-utils,
               linux-libc-dev [linux-any],
               meson (>= 0.52.0),
               pkg-config (>= 0.16.0),
               python3-dbus <!nocheck>,
               python3-distutils,
               python3-gi <!nocheck>,
               python3:any (>= 2.7.5-5~),
               shared-mime-info <!nocheck>,
               tzdata <!nocheck>,
               xsltproc,
               xterm <!nocheck>,
               zlib1g-dev
Rules-Requires-Root: no
Standards-Version: 4.5.0
Homepage: http://www.gtk.org/
Vcs-Browser: https://salsa.debian.org/gnome-team/glib
Vcs-Git: https://salsa.debian.org/gnome-team/glib.git -b ubuntu/focal

Package: libglib2.0-0
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Recommends: libglib2.0-data,
            shared-mime-info,
            xdg-user-dirs
Breaks: gimp (<< 2.10.14-3~),
        glib-networking-tests (<< 2.63.2),
        libgio-fam (<< 2.64.1-2~) [kfreebsd-any hurd-any],
        libgirepository-1.0-1 (<< 1.62.0-4~),
        libgladeui-2-6 (<< 3.22.2)
Replaces: libgio-fam (<< 2.64.1-2~) [kfreebsd-any hurd-any]
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Description: GLib library of C routines
 GLib is a library containing many useful C routines for things such
 as trees, hashes, lists, and strings.  It is a useful general-purpose
 C library used by projects such as GTK+, GIMP, and GNOME.
 .
 This package contains the shared libraries.

Package: libglib2.0-tests
Build-profiles: <!noinsttest>
Architecture: any
Depends: gir1.2-glib-2.0,
         libglib2.0-dev-bin,
         python3-dbus,
         python3-dbusmock,
         python3-gi,
         shared-mime-info,
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Recommends: xdg-desktop-portal,
Pre-Depends: ${misc:Pre-Depends}
Description: GLib library of C routines - installed tests
 GLib is a library containing many useful C routines for things such
 as trees, hashes, lists, and strings.  It is a useful general-purpose
 C library used by projects such as GTK+, GIMP, and GNOME.
 .
 This package contains test programs, designed to be run as part of a
 regression testsuite.

Package: libglib2.0-udeb
Build-Profiles: <!noudeb>
Section: debian-installer
Package-Type: udeb
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: GLib library of C routines - minimal runtime
 This is a udeb, or a microdeb, for the debian-installer.
 .
 GLib is a library containing many useful C routines for things such
 as trees, hashes, lists, and strings.  It is a useful general-purpose
 C library used by projects such as GTK+, GIMP, and GNOME.
 .
 This package contains the minimal runtime library needed by the Debian
 installer.

Package: libglib2.0-bin
Section: misc
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: libglib2.0-0 (= ${binary:Version}),
         libglib2.0-data,
         ${misc:Depends},
         ${shlibs:Depends}
Multi-Arch: foreign
Description: Programs for the GLib library
 GLib is a library containing many useful C routines for things such
 as trees, hashes, lists, and strings.  It is a useful general-purpose
 C library used by projects such as GTK+, GIMP, and GNOME.
 .
 This package contains the program files which is used for the libraries
 and others.

Package: libglib2.0-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libffi-dev (>= 3.3),
         libglib2.0-0 (= ${binary:Version}),
         libglib2.0-bin (= ${binary:Version}),
         libglib2.0-dev-bin (= ${binary:Version}),
         libmount-dev (>= 2.28) [linux-any],
         libpcre3-dev (>= 1:8.31),
         libselinux1-dev [linux-any],
         pkg-config,
         zlib1g-dev,
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Breaks: libglib2.0-0-dbg (<< 2.51.4-1~)
Replaces: libglib2.0-0-dbg (<< 2.51.4-1~)
Suggests: libgirepository1.0-dev (>= 1.62),
          libglib2.0-doc
Description: Development files for the GLib library
 GLib is a library containing many useful C routines for things such
 as trees, hashes, lists, and strings.  It is a useful general-purpose
 C library used by projects such as GTK+, GIMP, and GNOME.
 .
 This package is needed to compile programs against libglib2.0-0,
 as only it includes the header files and static libraries (optionally)
 needed for compiling.
 .
 GObject-Introspection metadata for this library can be found in the
 libgirepository1.0-dev package.

Package: libglib2.0-dev-bin
Section: libdevel
Architecture: any
Depends: python3-distutils,
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Suggests: libgdk-pixbuf2.0-bin (>= 2.36.12-2~) | libgdk-pixbuf2.0-dev,
          libxml2-utils
Breaks: libglib2.0-bin (<< 2.54.2-5~),
        libglib2.0-dev (<< 2.53)
Replaces: libglib2.0-bin (<< 2.54.2-5~),
          libglib2.0-dev (<< 2.53)
Multi-Arch: foreign
Description: Development utilities for the GLib library
 GLib is a library containing many useful C routines for things such
 as trees, hashes, lists, and strings.  It is a useful general-purpose
 C library used by projects such as GTK+, GIMP, and GNOME.
 .
 This package is needed to compile programs against libglib2.0-0. It contains
 development utilities typically run during compilation and should not be
 installed directly. Use libglib2.0-dev instead.

Package: libglib2.0-data
Architecture: all
Depends: ${misc:Depends}
Multi-Arch: foreign
Description: Common files for GLib library
 GLib is a library containing many useful C routines for things such
 as trees, hashes, lists, and strings.  It is a useful general-purpose
 C library used by projects such as GTK+, GIMP, and GNOME.
 .
 This package is needed for the runtime libraries to display messages in
 languages other than English.

Package: libglib2.0-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Suggests: devhelp
Multi-Arch: foreign
Description: Documentation files for the GLib library
 GLib is a library containing many useful C routines for things such
 as trees, hashes, lists, and strings.  It is a useful general-purpose
 C library used by projects such as GTK+, GIMP, and GNOME.
 .
 This package contains the HTML documentation for the GLib library
 in /usr/share/doc/libglib2.0-doc/ .

=== debian/rules ===
#!/usr/bin/make -f

binaries := $(shell dh_listpackages)

export DEB_BUILD_MAINT_OPTIONS=hardening=+bindnow

# Ensure the build aborts when there are still references to undefined symbols
DEB_LDFLAGS_MAINT_APPEND += -Wl,-z,defs

# NB: do NOT use -Wl,--as-needed to build glib; for instance the link to
# pthread is carefully crafted to allow dlopen()ing pthread-using libs; see
# http://mid.gmane.org/1257999019.21780.15.camel@marzipan
DEB_LDFLAGS_MAINT_APPEND += -Wl,--no-as-needed

# Make the linker work a bit harder so dynamic loading can be done faster
DEB_LDFLAGS_MAINT_APPEND += -Wl,-O1

include /usr/share/dpkg/default.mk

%:
	dh $@ --with gnome,python3 --buildsystem=meson

override_dh_autoreconf:
	@:

ifneq ($(filter hppa,$(DEB_HOST_ARCH_CPU)),)
stack_grows_up = true
else
stack_grows_up = false
endif

ifneq ($(filter kfreebsd,$(DEB_HOST_ARCH_OS)),)
have_non_stub_xattr = false
else
have_non_stub_xattr = true
endif

export DH_MESON_CROSS_FILE = debian/cross.txt

# We edit the debcrossgen output to work around unimplemented feature
# request https://bugs.debian.org/912559
override_dh_auto_configure:
ifneq ($(DEB_HOST_ARCH),$(DEB_BUILD_ARCH))
	/usr/share/meson/debcrossgen \
		-o debian/cross.txt.in
	debian/set-cross-properties \
		have_c99_snprintf=true \
		have_c99_vsnprintf=true \
		have_strlcpy=false \
		have_unix98_printf=true \
		growing_stack=$(stack_grows_up) \
		< debian/cross.txt.in > debian/cross.txt
endif
	dh_auto_configure \
		--builddirectory=debian/build/deb \
		-- \
		$(DEB_CONFIGURE_EXTRA_FLAGS) \
		$(DEB_CONFIGURE_FLAGS_deb) \
		$(NULL)
ifneq ($(filter %-udeb,$(binaries)),)
	dh_auto_configure \
		--builddirectory=debian/build/udeb \
		-- \
		$(DEB_CONFIGURE_EXTRA_FLAGS) \
		$(DEB_CONFIGURE_FLAGS_udeb) \
		$(NULL)
endif

override_dh_clean:
	rm -rf $(CURDIR)/debian/build \
	       $(CURDIR)/debian/install \
	       $(CURDIR)/debian/tmp-xdg-runtime-dir
	dh_clean -Xorg.gtk.test.gschema.xml.orig -Xorg.gtk.test.gschema.override.orig


override_dh_makeshlibs:
	dh_makeshlibs -plibglib2.0-tests -n
	dh_makeshlibs --remaining-packages --add-udeb=libglib2.0-udeb -Xlibgiofam.so -- -c4

override_dh_strip:
	dh_strip --dbgsym-migration='libglib2.0-0-dbg (<< 2.51.4-1~)'

# (Ubuntu-specific)
# Don't strip translations from the installed tests; makes them environment dependent.
override_dh_translations:
	dh_translations -Xinstalled-tests

# Do not clutter $HOME with ~/.dbus-keyrings and avoid failure on the buildds
# where creating /home/buildd/.dbus-keyrings fails
export HOME=$(CURDIR)/debian/build

# Put these back to their defaults if we are not running with a clean
# environment, so that they are based on the temporary $HOME above.
# Otherwise, some tests would try to write to the user's real XDG_DATA_HOME,
# causing unwanted side-effects or FTBFS depending whether the user's
# real HOME is available in the build chroot (if used)
unexport XDG_CACHE_HOME
unexport XDG_CONFIG_DIRS
unexport XDG_CONFIG_HOME
unexport XDG_DATA_HOME
unexport XDG_DATA_DIRS

# Make sure that everything that uses D-Bus is creating its own temporary
# session rather than polluting the developer's (or failing, on buildds)
export DBUS_SESSION_BUS_ADDRESS=this-should-not-be-used-and-will-fail:

ifeq ($(DEB_HOST_ARCH_OS), linux)
handle_test_failure := exit $$?
else
handle_test_failure := true
endif

# Upstream test timeouts assume an otherwise unloaded system, but that
# isn't necessarily the case for a porterbox or multiple parallel builds
test_timeout_multiplier = 3

ifneq ($(filter arm hppa mips% sparc%,$(DEB_HOST_ARCH_CPU)),)
$(info Slow architecture detected, increasing test timeout)
test_timeout_multiplier = 5
endif

ifneq ($(filter m68k riscv64 sh4,$(DEB_HOST_ARCH_CPU)),)
$(info Architecture with qemu buildds detected, increasing test timeout a lot)
test_timeout_multiplier = 20
endif

override_dh_auto_test-arch:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	# Remove LD_PRELOAD so we don't run with fakeroot, which makes dbus-related tests fail
	# First run the non-flaky tests, and fail the build if they fail (on linux)
	env -u LD_PRELOAD \
		DEB_BUILD_TIME_TESTS=1 \
		LC_ALL=C.UTF-8 \
		MESON_TESTTHREADS=1 \
	meson test -C debian/build/deb \
		--no-rebuild \
		--num-processes 1 \
		--timeout-multiplier $(test_timeout_multiplier) \
		--no-suite flaky \
		--verbose \
	|| $(handle_test_failure)
	# and then run the flaky ones, but ignore them failing
	env -u LD_PRELOAD \
		DEB_BUILD_TIME_TESTS=1 \
		LC_ALL=C.UTF-8 \
		MESON_TESTTHREADS=1 \
	meson test -C debian/build/deb \
		--no-rebuild \
		--num-processes 1 \
		--timeout-multiplier $(test_timeout_multiplier) \
		--suite flaky \
		--verbose \
	|| true
endif

# Skip build-time tests if all we are building is documentation; running
# them once per architecture is plenty
override_dh_auto_test-indep:
	@:

# The tests assume this directory exists and is writable
export XDG_RUNTIME_DIR=$(CURDIR)/debian/tmp-xdg-runtime-dir
# Let's get failing tests' stdout and stderr so we have some information when
# a build fails
export VERBOSE=1

ifeq ($(DEB_HOST_ARCH_OS),linux)
enable_libmount := enabled
enable_selinux := enabled
else
enable_libmount := disabled
enable_selinux := disabled
endif

ifneq ($(filter hurd,$(DEB_HOST_ARCH_OS)),)
use_fam := true
else
use_fam := false
endif

# configure flags
DEB_CONFIGURE_EXTRA_FLAGS := \
	-Dinternal_pcre=false \
	$(NULL)

DEB_CONFIGURE_FLAGS_deb := \
	--default-library both \
	-Dfam=$(use_fam) \
	-Dinstalled_tests=true \
	-Dlibmount=$(enable_libmount) \
	-Dman=true \
	-Dselinux=$(enable_selinux) \
	-Dsystemtap=true \
	-Dxattr=$(have_non_stub_xattr) \
	$(NULL)

ifneq ($(filter libglib2.0-doc,$(binaries)),)
DEB_CONFIGURE_FLAGS_deb += -Dgtk_doc=true
else
DEB_CONFIGURE_FLAGS_deb += -Dgtk_doc=false
endif

DEB_CONFIGURE_FLAGS_udeb := \
	--default-library shared \
	-Dgtk_doc=false \
	-Dinstalled_tests=false \
	-Dlibmount=disabled \
	-Dselinux=disabled \
	-Dxattr=$(have_non_stub_xattr) \
	$(NULL)

override_dh_auto_build:
	mkdir -p debian/tmp-xdg-runtime-dir
	dh_auto_build --builddirectory=debian/build/deb
ifneq ($(filter %-udeb,$(binaries)),)
	dh_auto_build --builddirectory=debian/build/udeb
endif

override_dh_auto_install:
	set -e; for script in postinst postrm triggers; do \
		sed -e"s/#MULTIARCH#/$(DEB_HOST_MULTIARCH)/g" \
		    -e"s/#ARCH#/$(DEB_HOST_ARCH)/g" \
		    debian/libglib2.0-0.$$script.in \
		    > debian/libglib2.0-0.$$script ; \
	done
ifneq ($(filter %-udeb,$(binaries)),)
	dh_auto_install -plibglib2.0-udeb --builddirectory=debian/build/udeb --destdir=debian/install/udeb
endif
	dh_auto_install --remaining-packages --builddirectory=debian/build/deb --destdir=debian/install/deb

override_dh_python3:
	# dh_python3 can't process both a private directory and /usr/bin
	# in the same invocation
	dh_python3 -plibglib2.0-dev-bin /usr/share/glib-2.0/codegen
	dh_python3 -plibglib2.0-tests --no-ext-rename /usr/libexec/installed-tests/glib
	dh_python3

override_dh_install:
	# Unwanted bits from the .deb build
	rm -fr debian/install/deb/usr/share/glib-2.0/codegen/__pycache__
ifneq ($(filter %-udeb,$(binaries)),)
	# Unwanted bits from the .udeb build
	rm -f debian/install/udeb/usr/lib/*/*.so
	rm -fr debian/install/udeb/usr/share/gdb
	rm -fr debian/install/udeb/usr/share/gettext/its
	rm -fr debian/install/udeb/usr/share/glib-2.0/codegen
	rm -fr debian/install/udeb/usr/share/glib-2.0/gdb
	rm -fr debian/install/udeb/usr/share/glib-2.0/valgrind
	rm -fr debian/install/udeb/usr/share/man
	dh_install -plibglib2.0-udeb --sourcedir=debian/install/udeb
endif
	dh_install --remaining-packages --sourcedir=debian/install/deb
	install -D -t debian/libglib2.0-0/usr/lib/${DEB_HOST_MULTIARCH}/glib-2.0/ debian/gio-launch-desktop

override_dh_dwz:
	dh_dwz -Nlibglib2.0-udeb

override_dh_missing:
	dh_missing --sourcedir=debian/install/deb --fail-missing
ifneq ($(filter %-udeb,$(binaries)),)
	dh_missing --sourcedir=debian/install/udeb --fail-missing
endif

## glib2.0 2.66.1

=== debian/changelog ===
glib2.0 (2.66.1-2) unstable; urgency=medium

  * Cherry-pick patches from the glib-2-66 branch upstream
    - Fixes the regression called out in 2.66.1-1's changelog.
  * Add-a-test-for-the-6-days-until-EOM-bug.patch,
    Fix-the-6-days-until-the-end-of-the-month-bug.patch: Cherry-pick upstream
    mr!1705 to not break on timezones built with `zic -b slim`

 -- Iain Lane <laney@debian.org>  Fri, 16 Oct 2020 17:38:50 +0100

glib2.0 (2.66.1-1) unstable; urgency=medium

  * Team upload
  * New upstream release
    - A performance problem where timezones were reloaded from disk
      every time a GTimeZone was created has been fixed (upstream issue
      #2204), but this means that changes to /etc/localtime will not take
      effect until a process restarts. Future changes in a subsequent
      2.66.x release will improve this.
    - Security fix for incorrect scope/zone ID parsing in URIs
    - Fix invalid Pointer Arithmetic in g_path_get_basename
    - Fix cookie lifetimes in GDBus DBUS_COOKIE_SHA1 mechanism
    - Fix faulty logic in DNS TXT record parsing
    - trash portal: Handle portal failures
    - gio-tool-trash: Prevent recursion to speed up emptying trash
    - glist: Clarify that g_list_free() and friends only free an entire list
    - gdatetime: Avoid integer overflow creating dates too far in the past
    - Translation updates
  * d/p/glocalfile-Never-require-G_LOCAL_FILE_STAT_FIELD_ATIME.patch,
    d/p/gdbusauthmechanismsha1-Use-the-same-timeouts-as-libdbus.patch:
    Drop patches that were applied upstream

 -- Simon McVittie <smcv@debian.org>  Mon, 12 Oct 2020 09:31:27 +0100

glib2.0 (2.66.0-2) unstable; urgency=medium

  * Team upload
  * d/p/glocalfile-Never-require-G_LOCAL_FILE_STAT_FIELD_ATIME.patch:
    Add proposed patch to fix file copying on ZFS and CIFS (Closes: #970228)
  * d/p/gdbus-server-auth-Don-t-usually-test-non-EXTERNAL-repeate.patch:
    Add proposed patch to work around DBUS_COOKIE_SHA1 test failures
  * d/p/Revert-gtk-doc-dependency-to-1.32.patch: Move to debian subdirectory.
    This patch is not intended to go upstream.

 -- Simon McVittie <smcv@debian.org>  Tue, 15 Sep 2020 22:12:49 +0100

glib2.0 (2.66.0-1) unstable; urgency=medium

  * Team upload
  * New upstream stable release
   - Fix missing tab in makefile rule
   - guri: Fix user passed to g_uri_split_with_user() not being NULL'd
   - Translation updates:
  * d/watch: Only watch for stable releases
  * d/p/gdbusauthmechanismsha1-Use-the-same-timeouts-as-libdbus.patch:
    Add patch to fix intermittent test failures on slower architectures.
    This narrowly missed the upstream code freeze, and should be in 2.66.1.

 -- Simon McVittie <smcv@debian.org>  Fri, 11 Sep 2020 09:18:58 +0100

glib2.0 (2.65.3-1) experimental; urgency=medium

  * New upstream release
    + Fixes to the new `statx()` calls — note that since GLib 2.65.2 uses
      `statx()` (if available) instead of
      `stat()`/`fstat()`/`lstat()`/`fstatat()`, syscall sandboxing for third
      party applications might need to be updated
    + Also includes "Fix splice behavior on cancellation", a fix for a bug
      which was affecting tracker - particularly its autopkgtests.

 -- Iain Lane <laney@debian.org>  Thu, 03 Sep 2020 18:55:20 +0100

glib2.0 (2.65.2-1) experimental; urgency=medium

  * Team upload
  * New upstream development release
  * d/rules: Run gtk-doc checks, even if building indep-only.
    Previously we would only run the gtk-doc checks if building
    architecture-dependent and -independent packages in the same build,
    which is done on Ubuntu amd64 buildds, but not on any Debian buildds.
  * Reduce dependency to the version of gtk-doc-tools from unstable.
    Instead of being some random snapshot from upstream git, this is the
    last release plus some selected patches. In particular, it has enough
    fixes to make the gtk-doc tests pass (Closes: #968975).
  * d/libglib2.0-tests.lintian-overrides: Update

 -- Simon McVittie <smcv@debian.org>  Tue, 25 Aug 2020 12:44:02 +0100

glib2.0 (2.65.1-1) experimental; urgency=medium

  [ Sebastien Bacher ]
  * debian/control.in:
    - let libglib2.0-tests Depends on libglib2.0-0 (= ${binary:Version}),
      otherwise we can end up with failures due to out of sync versions

  [ Simon McVittie ]
  * d/shlibs.local: Upgrade all binary packages in lockstep.
    Like many projects where one source package builds multiple binary
    packages, GLib has private headers that share non-public interfaces
    between its binary packages. Instead of setting this up for individual
    binary packages, we can tell dpkg-shlibdeps to generate lockstep
    dependencies whenever one of our binary packages depends on our shared
    libraries.
  * d/watch, d/control.in, d/gbp.conf: Branch for experimental
  * New upstream development release
    - Require the experimental version of gtk-doc-tools.
      GLib 2.65.x requires a version that hasn't been released yet.
    - Update symbols file
    - Drop patches that were applied upstream

 -- Simon McVittie <smcv@debian.org>  Fri, 07 Aug 2020 15:44:34 +0100

=== debian/control ===
--- 
+++ 
@@ -5,8 +5,7 @@
 Source: glib2.0
 Section: libs
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian GNOME Maintainers <pkg-gnome-maintainers@lists.alioth.debian.org>
+Maintainer: Debian GNOME Maintainers <pkg-gnome-maintainers@lists.alioth.debian.org>
 Uploaders: Iain Lane <laney@debian.org>
 Build-Depends: dbus <!nocheck>,
                debhelper-compat (= 12),
@@ -18,12 +17,11 @@
                dpkg-dev (>= 1.17.14),
                gettext,
                gnome-pkg-tools (>= 0.11),
-               gtk-doc-tools (>= 1.32-4~),
                libdbus-1-dev (>= 1.2.14) <!nocheck> <!noinsttest>,
                libelf-dev (>= 0.142),
                libffi-dev (>= 3.3),
                libgamin-dev [hurd-any] | libfam-dev [hurd-any],
-               libmount-dev (>= 2.28) [linux-any],
+               libmount-dev (>= 2.35.2-7~) [linux-any],
                libpcre3-dev (>= 1:8.35),
                libselinux1-dev [linux-any],
                libxml2-utils,
@@ -39,11 +37,12 @@
                xsltproc,
                xterm <!nocheck>,
                zlib1g-dev
+Build-Depends-Indep: gtk-doc-tools (>= 1.32-4~),
 Rules-Requires-Root: no
 Standards-Version: 4.5.0
 Homepage: http://www.gtk.org/
 Vcs-Browser: https://salsa.debian.org/gnome-team/glib
-Vcs-Git: https://salsa.debian.org/gnome-team/glib.git -b ubuntu/focal
+Vcs-Git: https://salsa.debian.org/gnome-team/glib.git -b debian/experimental
 
 Package: libglib2.0-0
 Architecture: any
@@ -110,8 +109,7 @@
 Section: misc
 Architecture: any
 Pre-Depends: ${misc:Pre-Depends}
-Depends: libglib2.0-0 (= ${binary:Version}),
-         libglib2.0-data,
+Depends: libglib2.0-data,
          ${misc:Depends},
          ${shlibs:Depends}
 Multi-Arch: foreign
@@ -131,7 +129,7 @@
          libglib2.0-0 (= ${binary:Version}),
          libglib2.0-bin (= ${binary:Version}),
          libglib2.0-dev-bin (= ${binary:Version}),
-         libmount-dev (>= 2.28) [linux-any],
+         libmount-dev (>= 2.35.2-7~) [linux-any],
          libpcre3-dev (>= 1:8.31),
          libselinux1-dev [linux-any],
          pkg-config,

=== debian/rules ===
--- 
+++ 
@@ -153,10 +153,18 @@
 	|| true
 endif
 
-# Skip build-time tests if all we are building is documentation; running
-# them once per architecture is plenty
+# Skip most build-time tests if all we are building is documentation;
+# running them once per architecture is plenty. As an exception, do run the
+# documentation completeness checks, which won't normally be run on
+# architecture-specific buildds (except in Ubuntu).
 override_dh_auto_test-indep:
-	@:
+	meson test -C debian/build/deb \
+		--no-rebuild \
+		--num-processes 1 \
+		--timeout-multiplier $(test_timeout_multiplier) \
+		--verbose \
+		gio-doc-check glib-doc-check gobject-doc-check \
+	|| $(handle_test_failure)
 
 # The tests assume this directory exists and is writable
 export XDG_RUNTIME_DIR=$(CURDIR)/debian/tmp-xdg-runtime-dir
@@ -250,13 +258,3 @@
 	dh_install -plibglib2.0-udeb --sourcedir=debian/install/udeb
 endif
 	dh_install --remaining-packages --sourcedir=debian/install/deb
-	install -D -t debian/libglib2.0-0/usr/lib/${DEB_HOST_MULTIARCH}/glib-2.0/ debian/gio-launch-desktop
-
-override_dh_dwz:
-	dh_dwz -Nlibglib2.0-udeb
-
-override_dh_missing:
-	dh_missing --sourcedir=debian/install/deb --fail-missing
-ifneq ($(filter %-udeb,$(binaries)),)
-	dh_missing --sourcedir=debian/install/udeb --fail-missing
-endif

## glib2.0 2.66.3

=== debian/changelog ===
glib2.0 (2.66.3-2) unstable; urgency=medium

  * Apply packaging changes from experimental to unstable:
    - postinst: Clean up outdated copies of GLib if present, to avoid
      infrequent upgrade issues on non-merged-/usr systems.
      See #911225 and #949395 for more information.
      (Closes: #896019, #954960, #955331)
  * Add myself to Uploaders
  * Standards-Version: 4.5.1 (no changes required)
  * Swap Homepage field to something more GLib-specific
  * d/gbp.conf: Change upstream branch to upstream/2.66.x.
    2.67.0 was already released, so it's inaccurate to say that 2.66.x
    is the latest.

 -- Simon McVittie <smcv@debian.org>  Wed, 02 Dec 2020 12:28:42 +0000

glib2.0 (2.66.3-1+exp1) experimental; urgency=medium

  * Merge from unstable

 -- Simon McVittie <smcv@debian.org>  Thu, 19 Nov 2020 20:47:54 +0000

glib2.0 (2.66.3-1) unstable; urgency=medium

  * Team upload
  * New upstream release
    - Improve performance of processing files hidden via ./.hidden
    - All other changes were already included in 2.66.2-1
  * Drop patches that were cherry-picked from upstream
  * Stop reverting gtk-doc dependency version.
    We now have a suitable gtk-doc in Debian.
  * Drop a patch that was not applied upstream.
    This was hoped to be a workaround for intermittent test failures, but
    doesn't seem to have had the desired effect in practice.
  * Mark the DBUS_COOKIE_SHA1 parts of gdbus-server-auth test as flaky.
    This is not reliable enough to always pass on buildds, but is too
    intermittent to be able to reproduce the failure in a development
    environment, and DBUS_COOKIE_SHA1 is not an important enough feature
    to justify failing the build for this.
    As with other flaky tests, we still run this as an autopkgtest in an
    attempt to get more useful information, but we ignore failure.

 -- Simon McVittie <smcv@debian.org>  Thu, 19 Nov 2020 11:11:06 +0000

glib2.0 (2.66.2-1+exp1) experimental; urgency=medium

  * Branch for experimental
  * postinst: Clean up outdated copies of GLib to avoid infrequent
    upgrade issues on non-merged-/usr systems
    (Closes: #896019, #954960, #955331)

 -- Simon McVittie <smcv@debian.org>  Sun, 01 Nov 2020 13:11:00 +0000

glib2.0 (2.66.2-1) unstable; urgency=medium

  * Team upload
  * New upstream release
    - Add some missing (nullable) and (not nullable) annotations
  * Drop patches that were cherry-picked from upstream
  * Update patch series to upstream 2.66.2-9-g4daaf303a
    - Fix race in socketclient-slow test
    - Cope with sending fds in a D-Bus message that takes multiple writes
    - Don't skip updating polled fd sources
    - Add G_GNUC_PRINTF annotation to g_trace_mark()
  * d/p/glib-tests-fileutils-Make-more-use-of-g_assert_no_errno.patch,
    d/p/glib-tests-fileutils-Fix-expectations-when-running-as-roo.patch:
    Add proposed patch to fix a test failure when running as root
    (Closes: #973271)
  * d/rules: Remove migration path from legacy -dbg package.
    This was most recently shipped in Debian 9, and we don't support
    upgrades from anything older than Debian 10.
  * Drop obsolete workaround for #887629.
    We don't support upgrades from versions older than Debian 10, so we can
    drop workarounds that were only relevant for the upgrade from 9 to 10.

 -- Simon McVittie <smcv@debian.org>  Sat, 31 Oct 2020 13:54:56 +0000

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
 Section: libs
 Priority: optional
 Maintainer: Debian GNOME Maintainers <pkg-gnome-maintainers@lists.alioth.debian.org>
-Uploaders: Iain Lane <laney@debian.org>
+Uploaders: Iain Lane <laney@debian.org>, Simon McVittie <smcv@debian.org>
 Build-Depends: dbus <!nocheck>,
                debhelper-compat (= 12),
                desktop-file-utils <!nocheck>,
@@ -37,10 +37,10 @@
                xsltproc,
                xterm <!nocheck>,
                zlib1g-dev
-Build-Depends-Indep: gtk-doc-tools (>= 1.32-4~),
+Build-Depends-Indep: gtk-doc-tools (>= 1.32.1),
 Rules-Requires-Root: no
-Standards-Version: 4.5.0
-Homepage: http://www.gtk.org/
+Standards-Version: 4.5.1
+Homepage: https://wiki.gnome.org/Projects/GLib
 Vcs-Browser: https://salsa.debian.org/gnome-team/glib
 Vcs-Git: https://salsa.debian.org/gnome-team/glib.git -b debian/experimental

## glib2.0 2.66.8

=== meson_options.txt ===
option('runtime_libdir',
       type : 'string',
       value : '',
       description : 'install runtime libraries relative to libdir')

option('iconv',
       type : 'combo',
       choices : ['auto', 'libc', 'external'],
       value : 'auto',
       description : 'iconv implementation to use (\'libc\' = \'Part of the C library\'; \'external\' = \'External libiconv\'; \'auto\' = \'Auto-detect which iconv is available\')')

option('charsetalias_dir',
       type : 'string',
       value : '',
       description : 'directory for charset.alias dir (default to \'libdir\' if unset)')

option('gio_module_dir',
       type : 'string',
       value : '',
       description : 'load gio modules from this directory (default to \'libdir/gio/modules\' if unset)')

option('selinux',
       type : 'feature',
       value : 'auto',
       description : 'build with selinux support')

option('xattr',
       type : 'boolean',
       value : true,
       description : 'build with xattr support')

option('libmount',
       type : 'feature',
       value : 'auto',
       description : 'build with libmount support')

option('internal_pcre',
       type : 'boolean',
       value : false,
       description : 'whether to use internal PCRE')

option('man',
       type : 'boolean',
       value : false,
       description : 'generate man pages (requires xsltproc)')

option('dtrace',
       type : 'boolean',
       value : false,
       description : 'include tracing support for dtrace')

option('systemtap',
       type : 'boolean',
       value : false,
       description : 'include tracing support for systemtap')

option('tapset_install_dir',
       type : 'string',
       value : '',
       description : 'path where systemtap tapsets are installed')

option('sysprof',
       type : 'feature',
       value : 'disabled',
       description : 'include tracing support for sysprof')

option('gtk_doc',
       type : 'boolean',
       value : false,
       description : 'use gtk-doc to build documentation')

option('bsymbolic_functions',
       type : 'boolean',
       value : true,
       description : 'link with -Bsymbolic-functions if supported')

option('force_posix_threads',
       type : 'boolean',
       value : false,
       description : 'Also use posix threads in case the platform defaults to another implementation (on Windows for example)')

option('fam',
       type : 'boolean',
       value : false,
       description : 'Use fam for file system monitoring')

option('installed_tests',
       type : 'boolean',
       value : false,
       description : 'enable installed tests')

option('nls',
       type : 'feature',
       value : 'auto',
       yield: true,
       description : 'Enable native language support (translations)')

option('oss_fuzz',
       type : 'feature',
       value : 'disabled',
       description : 'Indicate oss-fuzz build environment')

option('glib_assert',
       type : 'boolean',
       value : true,
       yield : true,
       description : 'Enable GLib assertion (see docs/macros.txt)')

option('glib_checks',
       type : 'boolean',
       value : true,
       yield : true,
       description : 'Enable GLib checks such as API guards (see docs/macros.txt)')

=== debian/changelog ===
glib2.0 (2.66.8-1) unstable; urgency=medium

  * d/watch: Only watch for 2.66.x versions.
    2.68.0 has been released but will not be in bullseye.
  * New upstream release
    - Functionally equivalent to 2.66.7-2, except for the version number
      and a change to Windows-specific code that is not used in Debian
  * Drop patches that were included in the new upstream release
  * d/p/glocalfileoutputstream-Tidy-up-error-handling.patch:
    Add patch from upstream to clean up error handling.
    After the fix for #984969, this function could end up calling close(-1),
    which is harmless but gets flagged as an error by static analysis and
    by error-checking instrumentation. Fixing this will prevent it from
    obscuring real errors.
  * Add CVE references in recent changelog entries.
    CVE IDs for the vulnerabilities were not available at the time they were
    fixed, but now they are.

 -- Simon McVittie <smcv@debian.org>  Sat, 20 Mar 2021 15:35:19 +0000

glib2.0 (2.66.7-2) unstable; urgency=medium

  * d/changelog: Add bug numbers for integer overflows in previous versions
  * Add patches to fix a symlink attack affecting file-roller.
    When g_file_replace() is used with G_FILE_CREATE_REPLACE_DESTINATION to
    replace a path that is a dangling symlink, previously it would have also
    created the target of the symlink as an empty file, which could
    conceivably be security-sensitive if the symlink is attacker-controlled.
    (Closes: #984969; CVE-2021-28153)

 -- Simon McVittie <smcv@debian.org>  Thu, 11 Mar 2021 10:23:38 +0000

glib2.0 (2.66.7-1) unstable; urgency=high

  * New upstream release
    - Fix another regression caused by the GHSL-2021-045 fixes in 2.66.6
    - Warn and fail on integer overflow in g_byte_array_new_take()
      for arrays larger than G_MAXUINT
      (Closes: #982779; CVE-2021-27218)
    - Disallow using currently-undefined D-Bus connection or server flags,
      to prevent forward-compatibility problems with new security-sensitive
      flags that are likely to be introduced in GLib 2.68
  * Drop previous patches for GHSL-2021-045 regressions, applied upstream

 -- Simon McVittie <smcv@debian.org>  Thu, 11 Feb 2021 17:08:14 +0000

glib2.0 (2.66.6-2) unstable; urgency=high

  * d/patches: Add proposed fixes for regressions in 2.66.6.
    Two functions that took either a positive length, or -1 to indicate
    strlen(), had assertions with the wrong sense in 2.66.6, causing some
    valid uses of those functions to regress.
  * d/p/debian/61_glib-compile-binaries-path.patch: Remove.
    This patch turns out to be unnecessary, and is harmful for
    cross-compiling. Thanks to Helmut Grohne (Closes: #982213)
  * Set high urgency to get the regression fixes into bullseye

 -- Simon McVittie <smcv@debian.org>  Mon, 08 Feb 2021 19:43:08 +0000

glib2.0 (2.66.6-1) unstable; urgency=high

  * New upstream release
    - Fix various integer overflows, some of them potentially exploitable
      (Closes: #982778; CVE-2021-27219, GHSL-2021-045)

 -- Simon McVittie <smcv@debian.org>  Thu, 04 Feb 2021 20:24:20 +0000

glib2.0 (2.66.5-1) unstable; urgency=medium

  * New upstream release, equivalent to 2.66.4-27-g0051c0635
  * Drop patches that were applied upstream

 -- Simon McVittie <smcv@debian.org>  Wed, 03 Feb 2021 19:16:01 +0000

glib2.0 (2.66.4-4) unstable; urgency=medium

  * d/patches: Update patch series to upstream commit 2.66.4-27-g0051c0635
    - Improve test coverage for #977961
    - Stop valgrind reporting memory leaks in GSpawn in most cases
    - Partially revert security hardening from 2.66.4-2: allow
      DBUS_SESSION_BUS_ADDRESS to be taken from the environment by
      setcap executables (to avoid regressing gnome-keyring) and by
      setgid executables (to avoid regressing msmtp).
      (Closes: #981420, #981555)
      Note that this is likely to be reverted in GLib 2.70.x to provide
      better hardening. The D-Bus session bus is not designed to be used
      by processes that have elevated privileges.

 -- Simon McVittie <smcv@debian.org>  Wed, 03 Feb 2021 13:55:41 +0000

glib2.0 (2.66.4-3) unstable; urgency=medium

  * Improve patch for #977961, and add basic test coverage

 -- Simon McVittie <smcv@debian.org>  Thu, 28 Jan 2021 19:05:50 +0000

glib2.0 (2.66.4-2) unstable; urgency=medium

  * d/patches: Update patch series to upstream commit 2.66.4-18-g872181c4f
    (excluding Windows-specific changes)
    - Security hardening: in GIO, ignore various environment variables
      if GIO is (inadvisably) used in a setuid process without sanitizing
      the environment first, similar to CVE-2012-3524
    - Reject very long date strings early, instead of spending time
      normalizing and parsing them
    - Fix recursion in GPrivate
  * d/p/spawn-Don-t-set-a-search-path-if-we-don-t-want-to-search-.patch:
    Make the g_spawn family only search PATH if G_SPAWN_SEARCH_PATH is used.
    Previously, they would sometimes search /usr/bin:/bin:. for an
    executable they should have only loaded from the current working
    directory. In particular, this made gtk+3.0 fail its build-time tests
    if ImageMagick display(1) happened to be installed. (Closes: #977961)

 -- Simon McVittie <smcv@debian.org>  Wed, 27 Jan 2021 11:33:06 +0000

glib2.0 (2.66.4-1) unstable; urgency=medium

  * New upstream release

 -- Simon McVittie <smcv@debian.org>  Fri, 18 Dec 2020 17:26:51 +0000

=== debian/tests/control ===
Tests: build build-static
Depends: libglib2.0-dev, build-essential
Restrictions: allow-stderr superficial

Tests: installed-tests
Depends: libglib2.0-tests, dbus-x11, dbus (>= 1.8), xauth, xvfb, gnome-desktop-testing
Restrictions: allow-stderr

Tests: flaky
Depends: libglib2.0-tests, dbus-x11, dbus (>= 1.8), xauth, xvfb, gnome-desktop-testing
Restrictions: allow-stderr flaky

Tests: bug896019 bug896019-biarch
Depends: dpkg-dev, libglib2.0-0
Restrictions: allow-stderr, breaks-testbed, needs-root, skippable

=== debian/watch ===
version=4
https://download.gnome.org/sources/glib/2.66/ \
	glib@ANY_VERSION@\.tar\.xz
